---
- name: set keycloak client config
  local_action: keycloak_client
  become: false
  args:
    auth_client_id: "{{ coder_keycloak_client_auth_client_id }}"
    auth_keycloak_url: "{{ coder_keycloak_client_auth_keycloak_url }}"
    auth_realm: "{{ coder_keycloak_client_auth_realm }}"
    auth_username: "{{ coder_keycloak_client_auth_username }}"
    auth_password: "{{ coder_keycloak_client_auth_password }}"
    client_id: "{{ coder_keycloak_client_client_id }}"
    realm: "{{ coder_keycloak_client_realm }}"
    redirect_uris: "{{ coder_keycloak_client_redirect_uris }}"
    client_authenticator_type: client-secret
    secret: "{{ coder_keycloak_client_secret }}"
    state: present
    direct_access_grants_enabled: false
    service_accounts_enabled: true
    validate_certs: "{{ coder_keycloak_client_validate_certs | default(true) }}"
    protocol_mappers:
      - name: groups
        config:
          access.token.claim: 'false'
          claim.name: groups
          full.path: 'false'
          id.token.claim: 'false'
          userinfo.token.claim: 'true'
        consentRequired: false
        protocol: openid-connect
        protocolMapper: oidc-group-membership-mapper

- name: "Create access_token for keycloak for user {{ coder_keycloak_client_auth_username }}"
  local_action: uri
  become: false
  args:
    url: "{{ coder_keycloak_client_auth_keycloak_url }}/realms/master/protocol/openid-connect/token"
    method: POST
    validate_certs: "{{ keycloak_validate_certs }}"
    body_format: form-urlencoded
    body:
      username: "{{ coder_keycloak_client_auth_username }}"
      password: "{{ coder_keycloak_client_auth_password | mandatory }}"
      grant_type: "password"
      client_id: "admin-cli"
  register: keycloak_token

- name: Map a client role to a service account user for a client, authentication with credentials
  community.general.keycloak_user_rolemapping:
    realm: "{{ coder_keycloak_client_realm }}"
    auth_keycloak_url: "{{ coder_keycloak_client_auth_keycloak_url }}"
    token: "{{ keycloak_token.json.access_token }}"
    state: present
    client_id: realm-management
    service_account_user_client_id : "{{ coder_keycloak_client_client_id }}"
    roles:
      - name: view-users
      - name: query-users
      - name: query-realms
      - name: view-realm

- name: Map a client role to a service account user for a client, authentication with credentials
  community.general.keycloak_user_rolemapping:
    realm: "{{ coder_keycloak_client_realm }}"
    auth_keycloak_url: "{{ coder_keycloak_client_auth_keycloak_url }}"
    token: "{{ keycloak_token.json.access_token }}"
    state: present
    client_id: account
    service_account_user_client_id : "{{ coder_keycloak_client_client_id }}"
    roles:
      - name: view-groups
